"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bound = exports.throws = exports.onlyOnce = exports.lazyInstantiate = void 0;
function lazyInstantiate(factory) {
    let instance = null;
    return () => {
        if (!instance)
            instance = factory();
        return instance;
    };
}
exports.lazyInstantiate = lazyInstantiate;
function onlyOnce(fn, ...args) {
    let called = false;
    return () => {
        if (!called) {
            called = true;
            fn(...args);
        }
    };
}
exports.onlyOnce = onlyOnce;
function throws(fn) {
    try {
        fn();
        return false;
    }
    catch {
        return true;
    }
}
exports.throws = throws;
function bound(value, min, max) {
    if (value < min)
        return min;
    if (value > max)
        return max;
    return value;
}
exports.bound = bound;
//# sourceMappingURL=misc.js.map